#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <ctime> 
#include <cstdlib>
#include <fstream> 


using namespace std;

typedef unsigned char  columna[6];
typedef columna tablero[7];

unsigned long long int nodos;
bool maquina_es_1;

vector <int> mejorjugada;
vector <int> recomendacion;
int profundidadrecursiva;

int zorbist[3][7][6];
map <long int, int> valoraciones;
long int position_key;

static long int rnd_seed = 1;

static long int rnd(void){
        long r = rnd_seed;
        r = 16807 * (r % 127773L) - 2836 * (r / 127773L);
        if (r < 0) r += 0x7fffffffL;
        return rnd_seed = r;
}

bool connect4(tablero &entrada){
     for(int i=0; i<7; ++i){
             for(int j=0; j<6; ++j){
                if(entrada[i][j]!=' '){
                     if(j<3){
						if(entrada[i][j]==entrada[i][j+1] and entrada[i][j+1] == entrada[i][j+2] and entrada[i][j+2] == entrada[i][j+3])  return true;
                     }
                     if(i<4){
						if(entrada[i][j]==entrada[i+1][j] and entrada[i+1][j] == entrada[i+2][j] and entrada[i+2][j] == entrada[i+3][j]) return true;
					 }
                     if(i<4 && j<3){
						if(entrada[i][j]==entrada[i+1][j+1] and entrada[i+1][j+1] == entrada[i+2][j+2] and entrada[i+2][j+2] == entrada[i+3][j+3]) return true;
					 }
                     if(j<3 && i>2){
						if(entrada[i][j]==entrada[i-1][j+1] and entrada[i-1][j+1]==entrada[i-2][j+2] and entrada[i-2][j+2]==entrada[i-3][j+3]) return true;
					 }
                  }
              }
     }
     return false;
}

void inicia_hash(){
	for(int i = 0; i < 3; ++i){
		for(int j = 0; j < 7; ++j){
			for(int k = 0; k < 6; ++k) zorbist[i][j][k] = rnd();
			}
		}
	}

int calcula_key(const tablero &entrada){
	int hash = 1;
	for(int i = 0; i < 7; ++i){
		for(int j = 0; j < 6; ++j){
			if(entrada[i][j] == ' ') hash ^= zorbist[2][i][j];
			else hash ^= zorbist[entrada[i][j]-'0'][i][j];
			}
		}
	return hash;
	}

void carga_hash(){
	map <long int, int> guardado;
	long int leer;
	ifstream hash ("hash.txt");
	while(hash >> leer) guardado[leer] = -10000;
	hash.close();
	valoraciones = guardado;
	}

void guarda_hash(){
	map <long int, int> guardado;
	long int leer;
	cout << "Operacion 1/2" << endl;
	ifstream hash ("hash.txt");
	while(hash >> leer) guardado[leer] = -10000;
	hash.close();
	map <long int, int> a_guardar;
	map<long int, int>::iterator it;
	for(it = valoraciones.begin(); it != valoraciones.end(); ++it){
		if(guardado.find(it->first) == guardado.end()){
			if(it->second < -100)a_guardar[it->first] = -10000; /**Siempre se calcula evalua la posicion cuando se ha perdido**/
			}
		}
	cout << "Operacion 2/2" << endl;
	ofstream hash2;
	hash2.open("hash.txt", fstream::out | fstream::app);
	for(it = a_guardar.begin(); it != a_guardar.end(); ++it){
		hash2 << it->first << endl;
		}
	hash2.close();
	cout << "El hash tiene " << guardado.size()+a_guardar.size() << endl;
	}

bool estalleno(const tablero &entrada){
     bool a=true;
     for(int i=0; i<7; ++i){
             if(entrada[i][5] == ' ') a=false;
     }
     return a;
}

void poneracero(tablero &entrada){
     for(int i=0; i<7; ++i){
             for(int j=0; j<6; ++j){
                     entrada[i][j] =' ';
             }
     }
}

void mostrartablero(const tablero &entrada){
     for(int i=0; i<6; ++i){
             cout<<"|";
             for(int j=0; j<7; ++j){
                     cout<<entrada[j][5-i];
             }
             cout<<"|"<<endl;
     }
     cout<<"\\-------/"<<endl;
     cout<<" 1234567 "<<endl << endl; //Los numeros ayudan ;)
}

bool meter(tablero &entrada, const int &sepone, const bool &letocarojo){
     bool sepuede;
     for(int i=0; i < 6; ++i){
             if(entrada[sepone][i]==' '){
						sepuede=true;
						position_key ^= zorbist[2][sepone][i];
                        if(letocarojo){
							position_key ^= zorbist[0][sepone][i];
							entrada[sepone][i]='0';
						}
                        else{
							position_key ^= zorbist[1][sepone][i];
							entrada[sepone][i]='1';
						}
                        break;
             }
             else sepuede=false;
     }
     return sepuede;
}

void sacar(tablero &entrada, int sequita){
	for(int i=5; i > -1; --i){
		if(entrada[sequita][i] != ' '){
			position_key ^= zorbist[entrada[sequita][i]-'0'][sequita][i];
			position_key ^= zorbist[2][sequita][i];
			entrada[sequita][i] = ' ';
			break;
			}
		}
	}

vector <int> gen_moves(const tablero &entrada){
       vector <int> res;
       for(int i=0; i<7; ++i){
               if(entrada[i][5] == ' ') res.push_back(i);
               }
       return res;
       }

bool acabado(tablero &principal){
     if(estalleno(principal) or connect4(principal)) return true;
     else                    return false;
     }



int evaluate(const tablero &entrada, bool letocaal0){
    int score[3]={0, 0, 0};
    string nums;
    if(letocaal0) nums = "01";
    else nums = "10";
    for(int k=0; k < 2; ++k){
         for(int j=0; j<6; ++j){
             for(int i=0; i<7; ++i){
                 if(entrada[i][j]==nums[k]){
                     if(j<3){
						 if(entrada[i][j+1]==nums[k] and entrada[i][j+2]==nums[k] and entrada[i][j+3]==nums[k]){
							 score[k]+=10000;
							 }
							 
						else if(entrada[i][j+1]==' ' and entrada[i][j+2]==nums[k] and entrada[i][j+3]==nums[k]){
							score[k]+=5;
						}
						else if(entrada[i][j+1]==nums[k] and entrada[i][j+2]==' ' and entrada[i][j+3]==nums[k]){
							score[k]+=5;
						}
						else if(entrada[i][j+1]==nums[k] and entrada[i][j+2]==nums[k] and entrada[i][j+3]==' '){
							score[k]+=5;
						}
						
					}
                     if(i<4){
						 if(entrada[i+1][j]==nums[k] and entrada[i+2][j]==nums[k] and entrada[i+3][j]==nums[k]){
							 score[k]+=10000;
						 }
						 
						 else if(entrada[i+1][j]==nums[k] and entrada[i+2][j]==nums[k] and entrada[i+3][j]==' '){
							 score[k]+=5;
						 }
						 else if(entrada[i+1][j]==nums[k] and entrada[i+2][j]==' ' and entrada[i+3][j]==nums[k]){
							 score[k]+=5;
						 }
						 else if(entrada[i+1][j]==' ' and entrada[i+2][j]==nums[k] and entrada[i+3][j]==nums[k]){
							 score[k]+=5;
						 }
						 
				 		}
                     if(i<4 && j<3){
						 if(entrada[i+1][j+1]==nums[k] and entrada[i+2][j+2]==nums[k] and entrada[i+3][j+3]==nums[k]){
							 score[k]+=10000;
						 }
						 
						 else if(entrada[i+1][j+1]==nums[k] and entrada[i+2][j+2]==nums[k] and entrada[i+3][j+3]==' '){
							 score[k]+=5;
						 }
						 else if(entrada[i+1][j+1]==nums[k] and entrada[i+2][j+2]==' ' and entrada[i+3][j+3]==nums[k]){
							 score[k]+=5;
						 }
						 else if(entrada[i+1][j+1]==' ' and entrada[i+2][j+2]==nums[k] and entrada[i+3][j+3]==nums[k]){
							 score[k]+=5;
						 }
					 }
                     if(j<3 && i>2){
						 if(entrada[i-1][j+1]==nums[k] and entrada[i-2][j+2]==nums[k] and entrada[i-3][j+3]==nums[k]){
							 score[k]+=10000;
						 }
						 
						 else if(entrada[i-1][j+1]==nums[k] and entrada[i-2][j+2]==nums[k] and entrada[i-3][j+3]==' '){
							score[k]+=5;
						 }
						 else if(entrada[i-1][j+1]==nums[k] and entrada[i-2][j+2]==' ' and entrada[i-3][j+3]==nums[k]){
							 score[k]+=5;
						 }
						 else if(entrada[i-1][j+1]==' ' and entrada[i-2][j+2]==nums[k] and entrada[i-3][j+3]==nums[k]){
							 score[k]+=5;
						 }
						 
                     }
                }
			}
		}
	}
    score[2] = score[0] - score[1];
    if(score[2] > 100) score[2] = 100000;
    else if(score[2] < -100) score[2] = -100000 - profundidadrecursiva;
    return score[2];
}
/**
int minimax (tablero &principal, bool letocaal0, int profundidad)
{
	++nodos;
     int mejor, puntaje;
     bool turnomaquina = (maquina_es_1 and !letocaal0) or (!maquina_es_1 and letocaal0);

     if (profundidad == 0  or acabado(principal))   { return evaluate (principal, maquina); }

     if (turnomaquina)		{ mejor = -9999; }
     else             		{ mejor = +9999; }
     
     vector <int> moves = gen_moves(principal);

     for (int i = 0; i <(int) moves.size(); ++i)
     {
         tablero p;
         for(int j=0; j<7; ++j){
             for(int k=0; k<6; ++k){ p[j][k] = principal[j][k];}}
          meter(p, moves[i], letocaal0);
          puntaje = minimax (p, !letocaal0, profundidad-1);

          if (turnomaquina && puntaje > mejor)
          {
               mejor=puntaje;  mejorjugada[profundidad-1]=moves[i];
          }
          else if (!turnomaquina && puntaje < mejor)
          {
               mejor=puntaje;  mejorjugada[profundidad-1]=moves[i];
          }
     }
     return mejor;
}**/

/**Si esta en el centro mejor**/
bool prioridad (const int &a, const int &b){
	if(a == recomendacion[profundidadrecursiva-1]) return true;
	else if(b == recomendacion[profundidadrecursiva-1]) return false;
	else return abs(3-a) < abs(3-b);
}

int negamax (tablero &entrada, bool lectocaal0, int profundidad, int alpha, int beta){
	 ++nodos;
	 profundidadrecursiva = profundidad;
	 	 	 
     if (profundidad == 0 or acabado(entrada)) {
		if(valoraciones.find(position_key) != valoraciones.end()){
			if(valoraciones[position_key] < -100) return valoraciones[position_key]-profundidad;
			else return valoraciones[position_key];
		}
		int p = evaluate (entrada, lectocaal0);
		valoraciones[position_key] = p;
		return p;
		}
     vector <int> moves = gen_moves(entrada);
     sort(moves.begin(), moves.end(), prioridad);

     for (int i = 0; i < (int) moves.size(); ++i){
			
          meter(entrada, moves[i], lectocaal0);
          int score = -negamax(entrada, !lectocaal0, profundidad-1, -beta, -alpha);
          sacar(entrada, moves[i]);
          
          if (score >= beta) { return beta; }
                              
          if (score > alpha){
	  		
               alpha = score;
               mejorjugada[profundidad-1] = moves[i];  
          }
     }
     return alpha;
}

int nosepuede (const tablero &input){
	int res = 7;
	for(int i=0; i<7; ++i){
		if(input[i][5] == ' ') res -=1;
		}
	return res;
	}
                                      
int main(){
    tablero principal;
    int entrada;
    string entry;
    bool otra = true;
    while(otra){
		poneracero(principal);
		bool letocal0=true;
		bool maquina, maquinasiempre = false;
		inicia_hash();
		carga_hash();
		cout << "Que jugador quieres ser? (0 o 1) \nteclea 2 si quieres que la maquina juegue contra ella misma" << endl;
		cin >> entry;
		if(entry[0]=='0') maquina_es_1 = true;
		else if(entry[0]=='1')maquina_es_1 = false;
		else maquinasiempre = true;
		int user, profundidad;
		cout << "Que profundidad desea?" << endl;
		cin >> user;
		while(user < 1){
			cout << "Meteme un numero positivo, no tiene sentido una profundidad negativa :S" << endl;
			cin >> user;
			}
		profundidad = user;
		while(!acabado(principal)){
			if(nosepuede (principal)==1) profundidad = user + 2;
			else if(nosepuede(principal) == 2) profundidad = user + 4;
			else if(nosepuede(principal) >= 3) profundidad = user + 10;
			bool letocaalamaquina = ((maquina_es_1 and !letocal0) or (!maquina_es_1 and letocal0)) or maquinasiempre;
                                if(letocaalamaquina){
                                           mejorjugada.resize(profundidad, 3);
                                           recomendacion.resize(profundidad, 3);
                                           bool final = false;
                                           vector <int> puntuaciones (profundidad);
                                           cout << "Profundidad \t Puntuacion \t Nodos \t Tiempo(ms) \t"; 
                                           cout << "nodos por ms"<< endl;
                                           cout << "--------------------------------------------------";
                                           cout << "-------------------" << endl;
                                           int solucion;
                                           for(int i=1; i <= profundidad and !final; ++i){
											   	position_key = calcula_key(principal);
											    nodos = 0;
											    clock_t t_ini = clock();
												int punt = negamax(principal, letocal0, i, -10000000, 10000000);
												clock_t t_fin = clock();
												double secs = (double)(t_fin - t_ini) / CLOCKS_PER_SEC;
												cout << i << "\t\t" << punt << "\t\t" << nodos << "\t\t" << secs*1000 << "\t\t";
												if(secs*1000 > 0)cout << nodos/(secs*1000) <<endl;
												else cout << "Poco tiempo" << endl;
												recomendacion = mejorjugada;
												if(punt > 100 or punt < -100) final = true;
												solucion = i;
											}
                                           meter(principal, mejorjugada[solucion-1], letocal0);
                                           //valoraciones.erase(valoraciones.begin(), valoraciones.end());                                 
                                           }
                                else{
                                     cout << "Donde quieres situar?" << endl;
                                     cin >> entrada;
                                     entrada-=1;
                                     if(!meter(principal, entrada, letocal0)){
										 letocal0 = !letocal0;
										 maquina = !maquina;
									 }
                                }
                                maquina = !maquina;
                                letocal0 = !letocal0;
                                mostrartablero(principal);
                                if(estalleno(principal)){ cout<<"FULL"<<endl;           mostrartablero(principal);}
								if(connect4(principal)){
									  cout<<"CONNECT4"<<endl;
									  mostrartablero(principal);
									  int punt = evaluate(principal, 0);
									  if(punt > 0) cout << "Ha ganado los 1's" << endl;
									  else cout << "Ha ganado los 0's" << endl;
								}
			}
			cout << "Espera mientras se guarda el hash" << endl;
			guarda_hash();
			cout << "Quieres jugar otra partida?(S/N)" << endl;
			cin >> entry;
			if(entry[0] == 'N' or entry[0] == 'n') otra =false;
		} 
}
