#include <iostream>
#include <vector>
#include <cstdlib> 

using namespace std;

typedef char tablero [3][3];

void iniciar (tablero &input){
	for(int i=0; i < 3; ++i){
		for(int j=0; j < 3; ++j){
			input[i][j] = ' ';
		}
	}
}

void print_board(const tablero &input){
	cout << "+---+---+---+   +---+---+---+" << endl;
	cout << "|";
	for(int i=0; i < 3; ++i){
		for(int j=0; j < 3; ++j){
			cout << " ";
			cout << input[i][j];
			cout << " |";
			}
		cout << "   |";
		for(int j=0; j < 3; ++j){
			cout << " "<< (i*3+j)+1 << " |";
			}
		cout << endl;
		cout << "+---+---+---+   +---+---+---+" << endl;
		if(i != 2)cout << "|";
		}
	}

bool threeonaline(const tablero &input){
	for(int i = 0; i < 3; ++i){
		if(input[0][i] != ' '){
			if(input[0][i] == input[1][i] and input[1][i] == input[2][i]) return true;
			}
		if(input[i][0] != ' '){
			if(input[i][0] == input[i][1] and input[i][1] == input[i][2]) return true;
			}
		}
	if(input[1][1] != ' ' and (input[0][0] == input[1][1] and input[1][1] == input[2][2])) return true;
	if(input[1][1] != ' ' and (input[0][2] == input[1][1] and input[1][1] == input[2][0])) return true;
	return false;
	}

bool full(const tablero &input){
	for(int i=0; i < 3; ++i){
		for(int j=0; j < 3; ++j){
			if(input[i][j] == ' ') return false;
			}
		}
	return true;
	}

bool fill(tablero &input, const int move, bool withX){
	if(input[move/3][move%3] == ' '){
		if(withX) input[move/3][move%3] = 'X';
		else      input[move/3][move%3] = 'O';
		return true;
	}
	else return false;
	}

void unfill(tablero &input, const int move){
	input[move/3][move%3] = ' ';
	}

int evaluate(const tablero &input, bool X){
	string bandos;
	if(X) bandos = "XO";
	else bandos = "OX";
	int score = 0;
	for(int j = 0; j < 2; ++j){
		int aux;
		if(j == 0) aux = 1;
		else aux = -1;
		for(int i = 0; i < 3; ++i){
			if(input[0][i] == bandos[j]){
				if(input[0][i] == input[1][i] and input[1][i] == input[2][i]) score+= aux;
			}
			if(input[i][0] == bandos[j]){
				if(input[i][0] == input[i][1] and input[i][1] == input[i][2]) score+= aux;
			}
		}
		if(input[1][1] == bandos[j] and (input[0][0] == input[1][1] and input[1][1] == input[2][2])) score+= aux;
		if(input[1][1] == bandos[j] and (input[0][2] == input[1][1] and input[1][1] == input[2][0])) score+= aux;
	}
	return score;
}

vector <int> gen_moves(const tablero &input){
	vector <int> res;
	for(int i=0; i < 3; ++i){
		for(int j=0; j < 3; ++j){
			if(input[i][j] == ' ') res.push_back((i*3)+j);
			}
		}
	return res;
	}

vector <int> mejoresjugadas (10);
/**Negamax, sin alfa ni beta**/
int negamax(tablero &actual, bool tocaX, int profundidad){
	
	if(full(actual) or threeonaline(actual)){ return evaluate(actual, tocaX); }
	
	int max = -99;
	vector <int> moves = gen_moves(actual);
	for(int i=0; i< (int) moves.size(); ++i){
		fill(actual, moves[i], tocaX);
		int valor = - negamax(actual, !tocaX, profundidad-1);
		unfill(actual, moves[i]);
		int random = rand()%2; /**Para darle gracia**/
		if(valor > max and random == 0){
			max = valor;
			mejoresjugadas[profundidad] = moves[i];
			}
		else if(valor >= max and random==1){
             max = valor;
			 mejoresjugadas[profundidad] = moves[i];
             }
             /** Si le quieres ensear a equivocarse annade esto
        else if(rand()%10 == 0){
              mejoresjugadas[profundidad] = moves[i];
             }**/
		}
	return max;
	}

int main(){
	tablero principal;
	int move;
	bool continuar = true;
	while(continuar){
		iniciar (principal);
		int opciones = -1;
		while (opciones < 1 or opciones > 4){
			cout << "Que tipo de juego quieres?" << endl;
			cout << "1: Maquina contra humano" << endl;
			cout << "2: Humano contra maquina" << endl;
			cout << "3: Maquina contra maquina" << endl;
			cout << "4: Humano contra humano" << endl;
			cin >> opciones;
			if(opciones < 1 or opciones > 4) cout << "Opcion incorrecta" << endl;
		}
		bool maquina, maquinasiempre = false, maquinanunca = false;
		if(opciones == 1) maquina = true;
		else if (opciones == 2) maquina = false;
		else if (opciones == 3){
			maquina = true;
			maquinasiempre = true;
			}
		else if (opciones == 4){
			maquina = false;
			maquinanunca = true;
			}
		bool withX = true;
		while(not threeonaline(principal) and not full(principal)){
			print_board(principal);
			bool turno_de_maquina = (maquina or maquinasiempre ) and not maquinanunca;
			if(turno_de_maquina){
				negamax(principal, withX, 9);
				fill(principal, mejoresjugadas[9], withX);
				}
			else{
				cout << "Donde quieres situar?" << endl;
				cin >> move;
				move -= 1;
				if(!fill(principal, move, withX)){
					cout << "Te equivocaste!!! esa casilla ya esta ocupada" << endl;
					withX = !withX;
					maquina = !maquina;
					}
			}
		withX = !withX;
		maquina = !maquina;
		}
		print_board(principal);
		cout << "El juego ha acabado" << endl;
		if(evaluate(principal, 0)==1) cout << "Ganan las O" << endl;
		else if(evaluate(principal, 0)==0) cout << "Empate" << endl;
		else if(evaluate(principal,0)==-1) cout << "Ganan las X" << endl;
        cout << "Quieres jugar otra?(S/N)" << endl;
		string ah;
		cin >> ah;
		if(ah[0] == 'N' or ah[0] == 'n') continuar = false;
	}
}
